
image: docker:latest
services:
    - docker:dind

variables:
    CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:test
    CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest
    DOCKER_RELEASE: ibrahimng/spring-boot-react:latest

stages:
    - Build
    - Push
    - Logout

before_script:
  - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY

build_job:
    stage: Build
    tags:
        - docker
    script:
        - docker build -t $CONTAINER_TEST_IMAGE .
        - docker push $CONTAINER_TEST_IMAGE

push_job:
    stage: Push
    tags:
        - docker
    script:
        - docker pull $CONTAINER_TEST_IMAGE  #docker push $CONTAINER_TEST_IMAGE
        - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
        - docker push $CONTAINER_RELEASE_IMAGE
        # Push to Docker Hub Registry
        - echo $DOCKER_PASSWORD | docker login -u $DOCKER_USER --password-stdin $DOCKER
        - docker tag $CONTAINER_RELEASE_IMAGE $DOCKER_RELEASE
        - docker push $DOCKER_RELEASE

logout_job:
    stage: Logout
    tags:
        - docker
    script:
        - docker logout

